#ifndef _TALKWINDOW_H_
#define _TALKWINDOW_H_
#include <windows.h>
#include "../systeminc/chat.h"

#define WM_UPDATE_SKIN 0x8000
#define MAX_TALK_WINDOW_LINE 6
#define TALK_WINDOW_SXO	12				// ԻӴֵʼx
#define TALK_WINDOW_SYO 10				// ԻӴֵʼy
#define TALK_WINDOW_SXI	30				// ԻӴֵʼx
#define TALK_WINDOW_SYI 128				// ԻӴֵʼy
#define SKIN_WIDTH 645
#define SKIN_HEIGHT 155
#define SKIN_KIND 5
#define TALK_WINDOW_MAX_CHAT_LINE 40 // buffer
#ifdef _STONDEBUG_
#define FACE_SYMBOL_NUM 20				// 
#define STORE_SYMBOL_NUM 200			// ¼λ
#define LINE_HEIGHT 20						// ʱо
#define SYMBOL_WIDTH 19						// ͼ
#define SYMBOL_HEIGHT 19					// ͼ
#endif

extern BOOL g_bTalkWindow;
extern int g_iCursorCount;

#ifdef _STONDEBUG_
typedef struct _tsFaceSymbol{				// 
	HDC hDraw;
	HDC hDrawMask;
	HBITMAP hbmpMaskBMP;
	HANDLE hLoadBMP;
	HANDLE hOldLoadBMP;
	HANDLE hOldMaskBMP;
	BOOL bUse;
	char szSymbol[8];					// ( :) :( :D ...etc)
	char szFaceName[32];			// 
}FaceSymbol;

typedef struct _tsStoreSymbol{				// ¼ʾ
	BOOL bUse;
	HDC hDraw;
	HDC hDrawMask;
	int x;
	int y;
}StoreSymbol;
#endif

typedef struct _tsChatBufferLink{
	CHAT_BUFFER ChatBuffer;
	_tsChatBufferLink *prev;
	_tsChatBufferLink *next;
	BOOL bUse;
}ChatBufferLink;

LRESULT CALLBACK TalkWindowProc(HWND hWnd,UINT Message,WPARAM wParam,LPARAM lParam);

class CTalkWindow
{
private:
	HWND m_hWnd;											// Ӵ HWND
	HWND m_hTalkWindow;								// Լ HWND
	HINSTANCE m_hInstance;						// Ӵ HINSTANCE
	HANDLE m_hSkin[SKIN_KIND];				// SKIN_KIND->0:base 1:up arrow 2:up arrow hit 3:down arrow 4:down arrow hit
	HANDLE m_hOldSkin[SKIN_KIND];
	HDC m_hdcSkin[SKIN_KIND];					// SKIN_KIND->0:base 1:up arrow 2:up arrow hit 3:down arrow 4:down arrow hit
	HDC m_hdcBackBuffer;							// backbuffer dc for draw
	HBITMAP m_hbmpBackBuffer;					// backbuffer of memory for draw
	HANDLE m_hbmpOldBackBuffer;
	BOOL m_bUpArrowHit;								// ϾťǷ
	BOOL m_bDownArrowHit;							// ¾ťǷ
	BOOL m_bScroll;										// Ƿھ
	BOOL m_bInit;											// ʼɹʧ
	ChatBufferLink *m_pCBLHead;				// ָԻlinkһlinkָ
	ChatBufferLink *m_pCBLTail;				// ָԻlinkһlinkָ
	ChatBufferLink *m_pCBLString;			// ָԻlink׼ִlinkָ
	ChatBufferLink *m_pCBLView;				// ָҪʾڻϵһеִlinkָ
	ChatBufferLink *m_pCBLViewBottom;	// ָҪʾڻһеִlinkָ
#ifdef _STONDEBUG_
	FaceSymbol m_fsFaceSymbol[FACE_SYMBOL_NUM];			// 
	StoreSymbol m_ssStoreSymbol[STORE_SYMBOL_NUM];	// ¼Ǳʾ
	int m_iSymbolCount;
#endif
	int m_iline;
public:
	CTalkWindow(void);
	~CTalkWindow(void);

	void Create();
	void Update(void);
	void LoadSkin(char *szSkinPath);
	void DrawSkin(BOOL bShowCursor);
	void AddString(char *szString,int color);
	HWND GetTalkWindowWND(void) { return m_hTalkWindow;};
	void UpArrowHit(BOOL bHit);
	void DownArrowHit(BOOL bHit);
	void ClearChatBuffer(void);
	void Init(HWND hWnd,HINSTANCE hInstance);
	void Visible(BOOL flag);
	void Release(void);
#ifdef _STONDEBUG_
	void ReadFaceSymbolFile(void);
	void InitFaceSymbol(COLORREF MaskColor);
	void ReleaseFaceSymbol(void);
	void SetToFaceSymbolString(char *szDestString,ChatBufferLink *pCBL,int x,int y);
	void ShowFaceSymbol(void);
#endif
};

extern CTalkWindow TalkWindow;

#endif